/* SGContentViewer.h
 *  
 * Copyright (C) 2004 Free Software Foundation, Inc.
 *
 * Author: Charles Philip Chan <cpchan@sympatico.ca>
 * Date: May 24, 2006
 *
 * This file is part of the GNUstep Inspector application
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02111 USA.
 */

#ifndef SGContentVIEWER_H
#define SGContentVIEWER_H

#include <Foundation/Foundation.h>
#include <AppKit/NSView.h>
#include "ContentViewersProtocol.h"
#include <vorbis/vorbisfile.h>
#include <ShengGuang/OGGEditor.h>
#import "NSTableDataSource.h"
#import "Id3/TagAPI.h"

@class NSBox;
@class NSTextField;
@class NSButton;
@class NSProgressIndicator;
@class NSWorkspace;
@class SGSound;
@class TagAPI;

@protocol ContentInspectorProtocol

- (void)contentsReadyAt:(NSString *)path;

@end 

@interface SGContentViewer : NSView <ContentViewersProtocol>
{
	NSString *soundPath;
	SGSound *sound;
	BOOL valid;
	NSBox *infoBox;
	NSBox *playBox;
	NSScrollView *scrollInfoView;
//    NSTextView *infoView;
	NSTableView *infoView;
        OGGEditor *anOgg;
	TagAPI * anMp3;
	id title;
	id length;
	id channels;
	id nominalOfBitrate;
	id upperOfBitrate;
	id lowerOfBitrate;
	id rate;
	NSString *time;
    
	NSTextField *errLabel;
	NSButton *playButt, *pauseButt, *stopButt;
	NSProgressIndicator *indicator;

	NSButton *editButt;
	
	id <ContentInspectorProtocol>inspector;
	NSWorkspace *ws;

  OggVorbis_File vf;
  FILE *in;
  NSString *_fname;
  NSMutableArray *tags;    
  int count;
  NSMutableDictionary *_info;
  
}

- (void)buttonsAction:(id)sender;

- (void)editFile:(id)sender;

@end

#endif // SGVIEWER_H
